"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var deployStack_1 = require("./cloudformation/deployStack");
var getDeployStatus_1 = require("./cloudformation/getDeployStatus");
var getOutputs_1 = require("./cloudformation/getOutputs");
var removeStack_1 = require("./cloudformation/removeStack");
var makeInlineLambda_1 = require("./lambda/makeInlineLambda");
var makeLambda_1 = require("./lambda/makeLambda");
var updateLambdaCode_1 = require("./lambda/updateLambdaCode");
var invokeLambda_1 = require("./lambda/invokeLambda");
var makeSimpleBucket_1 = __importDefault(require("./s3/makeSimpleBucket"));
var makeBucket_1 = __importDefault(require("./s3/makeBucket"));
var getFile_1 = __importDefault(require("./s3/getFile"));
var getFileUrl_1 = __importDefault(require("./s3/getFileUrl"));
var removeFile_1 = __importDefault(require("./s3/removeFile"));
var uploadFile_1 = require("./s3/uploadFile");
var makeLambdaEndpoint_1 = require("./apigateway/makeLambdaEndpoint");
var makeArtifactBucket_1 = require("./codestar/cf/makeArtifactBucket");
var makeGithubConnection_1 = require("./codestar/cf/makeGithubConnection");
var makeBuildProject_1 = require("./codestar/cf/makeBuildProject");
var makePipeline_1 = require("./codestar/cf/makePipeline");
var index_1 = require("./keywords/index");
exports.default = {
    cloudformation: {
        deployStack: deployStack_1.deployStack,
        getDeployStatus: getDeployStatus_1.getDeployStatus,
        getOutputs: getOutputs_1.getOutputs,
        removeStack: removeStack_1.removeStack
    },
    lambda: {
        makeInlineLambda: makeInlineLambda_1.makeInlineLambda,
        makeLambda: makeLambda_1.makeLambda,
        updateLambdaCode: updateLambdaCode_1.updateLambdaCode,
        invokeLambda: invokeLambda_1.invokeLambda
    },
    s3: {
        makeBucket: makeBucket_1.default,
        makeSimpleBucket: makeSimpleBucket_1.default,
        getFile: getFile_1.default,
        getFileUrl: getFileUrl_1.default,
        removeFile: removeFile_1.default,
        uploadFile: uploadFile_1.uploadFile
    },
    apigateway: {
        makeLambdaEndpoint: makeLambdaEndpoint_1.makeLambdaEndpoint
    },
    codestar: {
        makeArtifactBucket: makeArtifactBucket_1.makeArtifactBucket,
        makeGithubConnection: makeGithubConnection_1.makeGithubConnection,
        makeBuildProject: makeBuildProject_1.makeBuildProject,
        makePipeline: makePipeline_1.makePipeline
    },
    keywords: {
        getKeyword: index_1.getKeyword
    }
};
